"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeUnnamed = exports.decode = exports.encodeUnnamed = exports.encode = void 0;
const writer_1 = require("./writer");
const reader_1 = require("./reader");
const tag_1 = require("./tag");
__exportStar(require("./tag"), exports);
__exportStar(require("./snbt"), exports);
function encode(name, tag) {
    const writer = new writer_1.TagWriter();
    writer.writeByte(tag_1.getTagType(tag));
    writer.writeString(name);
    writer.write(tag);
    return writer.finish();
}
exports.encode = encode;
function encodeUnnamed(tag) {
    const writer = new writer_1.TagWriter();
    writer.writeByte(tag_1.getTagType(tag));
    writer.write(tag);
    return writer.finish();
}
exports.encodeUnnamed = encodeUnnamed;
function decode(buffer, options) {
    const reader = new reader_1.TagReader(buffer, options);
    const type = reader.readByte();
    return {
        name: reader.readString(),
        tag: reader.read(type),
        length: reader.getBytesRead()
    };
}
exports.decode = decode;
function decodeUnnamed(buffer, options) {
    const reader = new reader_1.TagReader(buffer, options);
    const type = reader.readByte();
    return {
        tag: reader.read(type),
        length: reader.getBytesRead()
    };
}
exports.decodeUnnamed = decodeUnnamed;
