"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTagType = exports.Float = exports.Int = exports.Short = exports.Byte = void 0;
class Byte {
    constructor(value) {
        this.value = value;
    }
    valueOf() { return this.value; }
}
exports.Byte = Byte;
class Short {
    constructor(value) {
        this.value = value;
    }
    valueOf() { return this.value; }
}
exports.Short = Short;
class Int {
    constructor(value) {
        this.value = value;
    }
    valueOf() { return this.value; }
}
exports.Int = Int;
class Float {
    constructor(value) {
        this.value = value;
    }
    valueOf() { return this.value; }
}
exports.Float = Float;
function getTagType(tag) {
    if (tag instanceof Byte)
        return 1;
    else if (tag instanceof Short)
        return 2;
    else if (tag instanceof Int)
        return 3;
    else if (typeof tag == "bigint")
        return 4;
    else if (tag instanceof Float)
        return 5;
    else if (typeof tag == "number")
        return 6;
    else if (tag instanceof Int8Array)
        return 7;
    else if (typeof tag == "string")
        return 8;
    else if (tag instanceof Array)
        return 9;
    else if (tag.constructor == Object || tag instanceof Map)
        return 10;
    else if (tag instanceof Int32Array)
        return 11;
    else if (tag instanceof BigInt64Array)
        return 12;
    throw new Error("Invalid tag type");
}
exports.getTagType = getTagType;
